<?php

/*
=====================================================================

  프로젝트 이름 : 피리 웹프로그램

  만든사람 : 피리 PIREE ( piree1977@gmail.com )

  홈페이지 : www.piree.kr

  작성날짜 : 2022년 11월 09일 수요일 오후 18시 28분 - 날씨 맑음, 12.4, 15, 3, 14%, 0%, 1.3ms / 상당히 나쁨, 94, 50

  저 작 권 : Copyright ⓒ 2014-2023 피리 piree.kr All right reserved
            그누보드 외에 추가된 소스는~
            만든사람의 허락없이 무단으로 사용할수 없습니다.
            사용하고자 할 경우 만든사람의 허락을 받아야 합니다.
            http://.piree.kr 에 문의해 주세요.

=====================================================================
 피리 > 피리 기본 관리 > 라이브러리 > 피리 웹프로그램 > DB 함수 관련
=====================================================================

//*****************************************************************
//** SAM_SOSS
//*****************************************************************

*/

/*
  ▣ 작업자 : 피리 PIREE ( piree1977@gmail.com )
  ▣ 작업일시 : 2020년 07월 24일 금요일 오전 05시 23분 - 날씨 
  ▣ 작업내용 : 
*/

  IF ( !defined('_GNUBOARD_') )                  EXIT;

/*
  $func_var_a = array();
  $func_var_a['func_table_c']//
  $func_var_a['func_wh_s']//
  $func_var_a['func_order_s']//
  $func_var_a['func_key_fd_c']//
  $func_var_a['func_get_fd_c']//
  $func_var_a['func_encode_c']//
*/
  function data_list_array_get($func_var_a)
  {

      $return_data_t = 0;

      $return_data_v = '';

      $loop_data_a = array();

      IF ( $func_var_a['func_table_c'] )
      {

          $return_data_a = array();

          $get_fd_c = '*';

          IF ( $func_var_a['func_key_fd_c'] && $func_var_a['func_get_fd_c'] )
          {

              $get_fd_c = "`". $func_var_a['func_key_fd_c'] ."`, `". $func_var_a['func_get_fd_c'] ."`";
          }

          $sql_select = "SELECT ". $get_fd_c ." FROM `". $func_var_a['func_table_c'] ."`";

          IF ( $func_var_a['func_wh_s'] )
          {

              $sql_select .= " WHERE ". $func_var_a['func_wh_s'];
          
          }

          IF ( $func_var_a['func_order_s'] )
          {

              $sql_select .= " ORDER BY ". $func_var_a['func_order_s'];
          
          }

          $result = sql_query($sql_select);

          WHILE ( $data_row = sql_fetch_array($result) )
          {

              IF ( $func_var_a['func_get_fd_c'] )
              {

                  $loop_data_a = $data_row[$func_var_a['func_get_fd_c']];

              }
              ELSE
              {

                  $loop_data_a = $data_row;

              }

              IF ( $func_var_a['func_key_fd_c'] )
              {

                  $loop_key_v = $data_row[$func_var_a['func_key_fd_c']];

                  $return_data_a[$loop_key_v] = $loop_data_a;

              }
              ELSE
              {

                  $return_data_a[] = $loop_data_a;

              }

              $return_data_t++;

          }

//$return_data_a['data_t'] = $return_data_t;

          IF ( $return_data_t > 0 )
          {

//($return_data_a);
//($return_data_a);

              SWITCH ($func_var_a['func_encode_c'])
              {

                  CASE 'json' :

                      $return_data_v = json_encode($return_data_a, JSON_UNESCAPED_UNICODE);
/*
                      $return_data_v = json_encode($return_data_a, JSON_PRETTY_PRINT);
                      $return_data_v = json_encode($return_data_a, JSON_UNESCAPED_UNICODE);
                      $return_data_v = json_encode($return_data_a, JSON_UNESCAPED_SLASHES);
*/

                  BREAK;

                  DEFAULT :

                      $return_data_v = $return_data_a;

                  BREAK;

              }

          }

      }

      return $return_data_v;

  }

/*
  $func_var_a = array();
  $func_var_a['func_table_c']//
  $func_var_a['func_update_sql_s']//
  $func_var_a['func_wh_s']//
*/
  function data_row_table_update($func_var_a)
  {

      $return_c = '';

      IF ( $func_var_a['func_table_c'] )
      {

          IF ( $func_var_a['func_update_sql_s'] )
          {

              IF ( $func_var_a['func_wh_s'] )
              {

                  $sql_updateate  = "UPDATE `". $func_var_a['func_table_c'] ."` SET ";
                  $sql_updateate .= $func_var_a['func_update_sql_s'] ." ";
                  $sql_updateate .= "WHERE ". $func_var_a['func_wh_s'];

                  IF ( sql_query($sql_updateate))
                  {

                      $return_c = 'UPDATE_QUERY_OK';

                  }
                  ELSE
                  {

                      $return_c = 'UPDATE_QUERY_FAIL';

                  }

              }

          }

      }

      return $return_c;

  }

/*
  $func_var_a = array();
  $func_var_a['func_get_table_c']//
  $func_var_a['func_get_wh_s']//
  $func_var_a['func_get_order_s']//
  $func_var_a['func_get_key_fd_c']//
  $func_var_a['func_get_get_fd_c']//
  $func_var_a['func_get_encode_c']//
  $func_var_a['func_save_table_c']//
  $func_var_a['func_save_wh_s']//
  $func_var_a['func_save_fd_n_c']//
  $func_var_a['func_save_fd_s_c']//
  $func_var_a['func_save_fd_modify_c']//
  $func_var_a['func_save_encode_c']//
*/
  function data_num_string_table_update($func_var_a)
  {

      $return_c = '';

      $data_t = 0;

      $data_json_enc = '';

      $put_var_a = array();
      $put_var_a['func_table_c']  = $func_var_a['func_get_table_c'];
      $put_var_a['func_wh_s']      = $func_var_a['func_get_wh_s'];
      $put_var_a['func_order_s']  = $func_var_a['func_get_order_s'];
      $put_var_a['func_key_fd_c']  = $func_var_a['func_get_key_fd_c'];
      $put_var_a['func_get_fd_c']  = $func_var_a['func_get_get_fd_c'];
      $put_var_a['func_encode_c']  = $func_var_a['func_get_encode_c'];

      $data_a = data_list_array_get($put_var_a);

      IF ( $data_a && count($data_a) > 0 )
      {

          IF ( $func_var_a['func_save_table_c'] )
          {

              $data_t = count($data_a);

              SWITCH ($func_var_a['func_save_encode_c'])
              {

                  CASE 'json' :

                      $data_json_enc = json_encode($data_a, JSON_UNESCAPED_UNICODE);
/*
                      $data_json_enc = json_encode($data_a, JSON_PRETTY_PRINT);
                      $data_json_enc = json_encode($data_a, JSON_UNESCAPED_UNICODE);
                      $data_json_enc = json_encode($data_a, JSON_UNESCAPED_SLASHES);
*/

                  BREAK;

                  DEFAULT :

                      $data_json_enc = $data_a;

                  BREAK;

              }

              $put_var_a = array();
              $put_var_a['func_table_c'] = $func_var_a['func_save_table_c'];
              $put_var_a['func_wh_s']    = $func_var_a['func_save_wh_s'];

              $put_var_a['func_update_sql_s']  = "`". $func_var_a['func_save_fd_n_c'] ."` = '". $data_t ."', ";
              $put_var_a['func_update_sql_s'] .= "`". $func_var_a['func_save_fd_s_c'] ."` = '". $data_json_enc ."'";

              IF ( $func_var_a['func_save_fd_modify_c'] )
              {

                  $put_var_a['func_update_sql_s'] .= ", `". $func_var_a['func_save_fd_modify_c'] ."` = '". G5_SERVER_TIME ."'";

              }

              data_row_table_update($put_var_a);

          }

      }

      return $return_c;

  }

?>